module Main where
import IO
import Alunos
import BSTree

main = do { hSetBuffering stdout NoBuffering
          ; ciclo Vazia
          }


ciclo :: BSTree Aluno -> IO ()
ciclo a = do { o <- menu 
             ;  case o of
                '1':_ -> do { a' <- insereAluno a 
                            ; ciclo a'
                            }
                '2':_ -> do { listaAlunos a
                            ; ciclo a
                            }
                '3':_ -> do { procuraAluno a
                            ; ciclo a
                            }
                '0':_ -> return ()
                otherwise -> do { putStrLn "Opo invlida"
                                ; ciclo a
                                } 
             }

menu :: IO String
menu = do { putStrLn menutxt 
          ; putStr "Opo: "
          ; c <- getLine 
          ; return c
          }
    where menutxt = unlines ["", 
                             "Inserir Aluno .......  1",
                             "Listar Alunos .......  2",
                             "Procurar Aluno ......  3",
                             "",
                             "Sar ................  0"]
                     
insereAluno :: BSTree Aluno -> IO (BSTree Aluno)
insereAluno a 
  = do { putStr "\nNmero: "; nu <- getLine
       ; putStr "Nome: "; no <- getLine
       ; putStr "Nota Prtica: " ; p <- getLine
       ; putStr "Nota Terica: "; t <- getLine
       ; return (insere a (A no (read nu) (read p) (read t)))
       }

listaAlunos :: BSTree Aluno -> IO ()
listaAlunos _ = return () --- para completar

procuraAluno :: BSTree Aluno -> IO ()
procuraAluno _ = return () --- para completar

pesquisaNumAluno Vazia x = Nothing
pesquisaNumAluno (Nodo r e d) x 
    | x < (numero r) = pesquisaNumAluno e x
    | x > (numero r) = pesquisaNumAluno d x
    | otherwise      = Just r

guarda :: BSTree Aluno -> IO ()
guarda _ = return () --- para completar

leInfo :: IO (BSTree Aluno)
leInfo = return Vazia --- para completar
